LeetCode 88 合并两个有序数组

描述

You are given two integer arrays nums1 and nums2, sorted in non-decreasing order, and two integers m and n, representing the number of elements in nums1 and nums2 respectively.

Merge nums1 and nums2 into a single array sorted in non-decreasing order.

The final sorted array should not be returned by the function, but instead be stored inside the array nums1. To accommodate this, nums1 has a length of m + n, where the first m elements denote the elements that should be merged, and the last n elements are set to 0 and should be ignored. nums2 has a length of n.

Example 1:

Input: nums1 = [1,2,3,0,0,0], m = 3, nums2 = [2,5,6], n = 3
Output: [1,2,2,3,5,6]
Explanation: The arrays we are merging are [1,2,3] and [2,5,6].
The result of the merge is [1,2,2,3,5,6] with the underlined elements coming from nums1.
Example 2:

Input: nums1 = [1], m = 1, nums2 = [], n = 0
Output: [1]
Explanation: The arrays we are merging are [1] and [].
The result of the merge is [1].

来源:力扣(LeetCode)
链接:https://leetcode.cn/problems/merge-sorted-array
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。

题解

/**
 * 合并两个有序数组
 * 由于数组已排序,可以用双指针,将数组看作队列,每次取两个队列头部中较小的一个插入
 * @param {number[]} nums1
 * @param {number} m
 * @param {number[]} nums2
 * @param {number} n
 * @return {void} Do not return anything, modify nums1 in-place instead.
 */
var merge = function (nums1, m, nums2, n) {
    nums2.length = n
    nums1.length = m
    const clone = nums1.splice(0, nums1.length)
    while (clone.length || nums2.length) {
        const curArr = compare(clone, nums2)
        nums1.push(curArr.shift())
    }
};

const compare = (arr1, arr2) => {
    if (!arr1.length || !arr2.length) {
        return arr1.length ? arr1 : arr2
    }
    return arr1[0] > arr2[0] ? arr2 : arr1
}

/**
 * 合并两个有序数组
 * 由于数组已排序,可以用双指针, 从后往前覆盖
 * 时间复杂度O(m+n), 指针移动单调递减,最多移动 m+n 次,
 * 空间复杂度O(1)
 * @param {number[]} nums1
 * @param {number} m
 * @param {number[]} nums2
 * @param {number} n
 * @return {void} Do not return anything, modify nums1 in-place instead.
 */
var merge = function (nums1, m, nums2, n) {
    let p1 = m - 1, p2 = n - 1, tail = m + n - 1
    let cur 
    while (p1 >= 0 || p2 >= 0){
        if(p1 === -1){
            cur = nums2[p2 --]
        }else if(p2 === -1){
            cur = nums1[p1 --]
        }else if(nums1[p1] > nums2[p2]){
            cur = nums1[p1 --]
        }else{
            cur = nums2[p2 --]
        }
        nums1[tail --] = cur 
    }
};

posted @ 2022-07-19 23:59  IslandZzzz  阅读(16)  评论(0编辑  收藏  举报